package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.EmpresaAdyenConfigDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaAdyenConfig;

@Repository("empresaAdyenConfigDAO")
public class EmpresaAdyenConfigHibernateDAO extends GenericHibernateDAO<EmpresaAdyenConfig, Integer>
		implements EmpresaAdyenConfigDAO {

	@Autowired
	public EmpresaAdyenConfigHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<EmpresaAdyenConfig> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public EmpresaAdyenConfig buscarPorEmpresa(Empresa empresa) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa", empresa));

		return (EmpresaAdyenConfig) c.uniqueResult();
	}
}
